// un jeu est défini de la façon suivante
// type : simple (une seule face questionne)
//		  double (on peut questionner des deux faces), un menu s'affiche pour donner le choix
// tailles : [t1, t2] t1 et t2 sont les tailles des textes sur les faces, prenant les variables petit, moyen, grand
// valeurs :[[q1,r1], [q2, r2], ...] q1 est la question 1, q2 est la question 2
var jeux = {
	'Table de 3' : { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["2xx3","6"],["3xx3","9"],["4xx3","12"],["5xx3","15"],["6xx3","18"],["7xx3","21"],["8xx3","24"],["9xx3","27"],["10xx3","30"],["11xx3","33"]]},
	'Table de 4' : { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["2xx4","8"],["3xx4","12"],["4xx4","16"],["5xx4","20"],["6xx4","24"],["7xx4","28"],["8xx4","32"],["9xx4","36"],["10xx4","40"],["11xx4","44"]]},
	'Table de 5' : { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["2xx5","10"],["3xx5","15"],["4xx5","20"],["5xx5","25"],["6xx5","30"],["7xx5","35"],["8xx5","40"],["9xx5","45"],["10xx5","50"],["11xx5","55"]]},
	'Table de 6' : { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["2xx6","12"],["3xx6","18"],["4xx6","24"],["5xx6","30"],["6xx6","36"],["7xx6","42"],["8xx6","48"],["9xx6","54"],["10xx6","60"],["11xx6","66"]]},
	'Table de 7' : { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["2xx7","14"],["3xx7","21"],["4xx7","28"],["5xx7","35"],["6xx7","42"],["7xx7","49"],["8xx7","56"],["9xx7","63"],["10xx7","70"],["11xx7","77"]]},
	'Table de 8' : { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["2xx8","16"],["3xx8","24"],["4xx8","32"],["5xx8","40"],["6xx8","48"],["7xx8","56"],["8xx8","64"],["9xx8","72"],["10xx8","80"],["11xx8","88"]]},
	'Table de 9' : { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["2xx9","18"],["3xx9","27"],["4xx9","36"],["5xx9","45"],["6xx9","54"],["7xx9","63"],["8xx9","72"],["9xx9","81"],["10xx9","90"],["11xx9","99"]]},
	'Table de 12' : { type:'double', entrees:['tex','tex'], tailles:['moyen','grand'], valeurs:[["2xx12","24"],["3xx12","36"],["4xx12","48"],["5xx12","60"],["6xx12","72"],["7xx12","84"],["8xx12","96"],["9xx12","108"],["10xx12","120"],["11xx12","132"]]},
	'Carrés de 2 à 20' : { type:'double', entrees:['tex','tex'], tailles:['moyen','grand'], valeurs:[["2xx2","4"],["3xx3","9"],["4xx4","16"],["5xx5","25"],["6xx6","36"],["7xx7","49"],["8xx8","64"],["9xx8","81"],["10xx10","100"],["11xx11","121"], ["12xx12","144"], ["13xx13","169"], ["14xx14","196"], ["15xx15","225"],["16xx16","256"],["17xx17","289"],["18xx18","324"],["19xx19","361"],["20xx20","400"]]},
	'Fractions décimales':{type:'double', entrees:['tex','tex'], tailles:['moyen','grand'], valeurs:[["1/2","0,5"],["3/2","1,5"],["5/2","2,5"],["1/4","0,25"],["3/4","0,75"],["5/4","1,25"],["1/5","0,2"],["2/5","0,4"],["3/5","0,6"],["4/5","0,6"]]},
	'PGCD de deux nombres':{type:'simple', entrees:['txt','tex'], tailles:['moyen','grand'], valeurs:[["PGCD de 6 et 9","3"],["PGCD de 10 et 15","5"],["PGCD de 5 et 8","1"],["PGCD de 27 et 12","3"],["PGCD de 16 et 12","4"],["PGCD de 12 et 10","2"],["PGCD de 30 et 18","6"],["PGCD de 14 et 35","7"],["PGCD de 30 et 25","5"],["PGCD de 4 et 6","2"]]},
	"Racines carrées parfaites": { type:'double', entrees:['tex','tex'], tailles:['grand','grand'], valeurs:[["sqrt(4)","2"],["sqrt(9)","3"],["sqrt(16)","4"],["sqrt(25)","5"],["sqrt(36)","6"],["sqrt(49)","7"],["sqrt(64)","8"],["sqrt(81)","9"],["sqrt(100)","10"],["sqrt(121)","11"], ["sqrt(144)","12"], ["sqrt(169)","13"], ["sqrt(196)","14"], ["sqrt(225)","15"]]}
}
$(function(){
	// Construction du menu
	var menu = "<ul style='float:left;' z-index='1000' class='vert-one'>";
	var jj = 0;
	for (i in jeux){
		jj++;
		menu += "<li><a id=\"id"+jj+"\" href=\"javascript:changeClassMenu('id"+jj+"');jeuEncours.init(jeux['"+i+"'], '"+i+"');\">"+i+"</a></li>";
	}
	menu += "</ul>";
	$("body").prepend(menu);
	afficheTitre = function(){// initialisation du jeu
		$("h1").text(jeuEncours.titre);
		$("#sousflipper").show();
		$("#flipper .front > div").removeClass().addClass(jeuEncours.tailles[0]);
		$("#flipper .back > div").removeClass().addClass(jeuEncours.tailles[1]);
		if(jeuEncours.type == 'double'){
			$('#mode').show();
		} else $('#mode').hide();
		// On ajoute des cartes sous le paquet pour simuler un paquet
		// Suppression de l'ancien paquet
		$("#sousflipper.clone").remove();
		var i=0;
		var top=6, left = -322;
		for (i=1;i<jeuEncours.paquet.length-1;i++){
			top = top-1;
			left = left-1;
			$("#sousflipper:first").before($("#sousflipper:first").clone());
			$("#sousflipper:first").addClass("clone");
			$("#sousflipper:first").css({"top":top+"px","margin-left":left+"px"});
		}
	}
	mode = function(mode){
		if(jeuEncours.mode == mode) return;
		jeuEncours.mode = mode;
		$("#mode a").removeClass('current');
		$("#a"+mode).addClass('current');
		afficheCarte();
	}
	changeClassMenu = function(lien){
		$(".vert-one a").removeClass('current');
		$("#"+lien).addClass('current');
		$("#afaces").addClass('current');
	}
	afficheCarte = function(){
		var delimiteur0 = "",delimiteur0="";
		var face="", dos="";
		var mode='faces';
		if(jeuEncours.entrees[0] == 'tex')delimiteur0 = "`";
		if(jeuEncours.entrees[1] == 'tex')delimiteur1 = "`";
		if(jeuEncours.mode == 'dos'){mode = 'dos';}
		else if(jeuEncours.mode == 'both'){
			if(utils.entier(0,1)){
				mode = 'dos';
			}
		}
		if(mode == 'faces'){
			face = delimiteur0+jeuEncours.paquet[0][0]+delimiteur0;
			dos = delimiteur1+jeuEncours.paquet[0][1]+delimiteur1;
			$("#flipper .front > div").removeClass().addClass(jeuEncours.tailles[0]+" face");
			$("#flipper .back > div").removeClass().addClass(jeuEncours.tailles[1]+" dos");
		} else if (mode == 'dos'){
			face = delimiteur1+jeuEncours.paquet[0][1]+delimiteur1;
			dos = delimiteur0+jeuEncours.paquet[0][0]+delimiteur0;
			$("#flipper .front > div").removeClass().addClass(jeuEncours.tailles[1]+" dos");
			$("#flipper .back > div").removeClass().addClass(jeuEncours.tailles[0]+" face");
		}
		$('#flipper .front div').text(face);
		$('#flipper .back div').text(dos);
		MathJax.Hub.Queue(["Typeset",MathJax.Hub]);
		$("#flipper").flip(false);
	}
	animeDefausse = function(reussite){
		if(jeuEncours.paquet.length==1){
			$("#sousflipper").hide();
		} else if(jeuEncours.paquet.length>1){
			$("#sousflipper:last").remove();
		}
		$("#copieflipper").show();
		// animation de la mise à la défausse
		$("#copieflipper").animate({
			left:'+=420px',
			height: '62px',
			width: '100px',
			top: '+=450px',
			fontSize: '1em',
			opacity: 0.3
		},function(){
			$("#copieflipper").remove();
			if(reussite)afficheCarte();
		});
		$("#copieflipper .front").animate({				
			borderWidth:'2px'
		});
		$("#copieflipper .front > div").animate({				
			borderWidth:'1px'
		});
	}
	$("#flipper").flip({axis:'x'});
	$("#ok").click(function(){
		if(!jeuEncours.encours)return false;
		$("#conteneur").append('<div id="copieflipper" z-index="10" style="diplay:none;"><div class="front"><div></div></div></div>');
		$("#flipper .front div").clone().appendTo("#copieflipper .front div");
		$("#flipper").flip(false);
		$('#flipper .front div').text("");
		$('#flipper .back div').text("");
		var reussite = jeuEncours.reussite();
		if(!reussite){ // il n'y a plus de carte
			$("#flipper .front div").text("Terminé !").removeClass().addClass("moyen");
			$("#flipper .back div").text("Terminé !").removeClass().addClass("moyen");
			jeuEncours.encours = false;
		}
		animeDefausse(reussite);
	});
	$("#notok").click(function(){
		if(!jeuEncours.encours)return false;
		jeuEncours.erreur();
		$('#flipper .front div').text("");
		$('#flipper .back div').text("");
		$("#flipper").flip(false);
		afficheCarte();
	});
});
var jeuEncours = {
	init: function(jeu, titre){
		this.mode = 'faces';
		this.titre = titre;
		this.entrees = jeu.entrees;
		this.paquet = [];
		for(i in jeu.valeurs){
			this.paquet.push(jeu.valeurs[i]);
		}
            // supprime l'entrée ajoutée en fin de tableau :
            if(typeof this.paquet[this.paquet.length-1] === "function")
                this.paquet.pop();
		this.paquet = utils.melangeTable(this.paquet);
		this.type = jeu.type;
		this.tailles = jeu.tailles;
		afficheTitre();
		afficheCarte();
		this.encours = true;
	},
	reussite:function(){
		if(this.paquet.length > 0){
			this.paquet.shift();
			return this.paquet.length;
		} else
			return false;
	},
	erreur : function(){
		this.paquet.push(this.paquet[0]);
		this.paquet.shift();
	}
};
