/* 
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

Array.prototype.indexOfForArrays = function (search)
{
    var searchJson = JSON.stringify(search); // "[3,566,23,79]"
    var arrJson = this.map(JSON.stringify); // ["[2,6,89,45]", "[3,566,23,79]", "[434,677,9,23]"]

    return arrJson.indexOf(searchJson);
};

var utils = {
    decimalFr: function (nbpoint) {
        var regexp = /text\{/;
        // remplace le séparateur décimal . par , et transforme en texte
        if (regexp.test(nbpoint) || !activite.tex)
            return String(nbpoint).replace(".", ",");
        else
            return "\\text{" + (String(nbpoint).replace(".", ",")) + "}";
    },
    ecritFr: function (nombre) {
        var regexp = /text\{/;
        // transforme l'écriture en écriture lisible (groupements par des chiffres par trois)
        var recherche = /(\..*)|\B(?=(\d{3})*\b)/g;
        if (regexp.test(nombre) || !activite.tex)
            return String(nombre).replace(recherche, "$1 ");
        else
            return "\\text{" + String(nombre).replace(recherche, "$1 ") + "}";
    },
    melangeTable: function (table) {
        var i, places, tmp;
        places = utils.entier(0, table.length - 1, table.length * 2);
        for (i = 0; i < table.length; i++) {
            tmp = table[places[2 * i + 1]];
            table[places[2 * i + 1]] = table[places[2 * i]];
            table[places[2 * i]] = tmp;
        }
        return table;
    },
    entier: function (borneinf, bornesup, nb) {
        // génération de nombres pseudo aléatoires par la méthode de Fibonacci
        if (nb === undefined)
            nb = 1;
        nb = Number(nb);
        borneinf = Number(borneinf);
        bornesup = Number(bornesup);
        var init, n1, n2, ii;
        var amplitude = bornesup - borneinf + 1;
        var entiers = Array();
        // cas où les bornes sont égales
        if (borneinf === bornesup) {
            if (nb === 1)
                return borneinf;
            else {
                for (iterate = 0; iterate < nb; iterate++) {
                    entiers[iterate] = borneinf;
                }
                return entiers;
            }
        }
        for (ii = 0; ii < nb; ii++) {
            init = Math.floor(100000000 * Math.random());
            n1 = Math.floor(init / 10000);
            n2 = init - Math.floor(init / 10000) * 10000;
            for (j = 0; j < 20; j++) {
                n1 = n1 + n2;
                n2 = n2 + n1;
            }
            entiers[ii] = n2 % amplitude + borneinf;
        }
        if (nb === 1)
            return entiers[0];
        else
            return entiers;
    },
    mult10: function (nombre) {
        // vérifie si un nombre est multiple de 10 ou non
        if (Math.floor(nombre / 10) * 10 === nombre) {
            return true;
        }
        else
            return false;
    },
    plusOuMoinsUn: function () {
        return utils.entier(0, 1) * 2 - 1;
    },
    objetToText: function (objet) {
        // transforme un objet en liste tex avec alignements
        if (typeof (objet) != "object") {
            return "Ce n'est pas un objet";
        }
        var chaine = "<ol>";
        var cpt = 0;
        for (i in objet) {
            if (cpt >= activite.nbq)
                break;
            cpt++;
            if (activite.tex)
                chaine += "<li class='math'>" + objet[i].reponse + "</li>";
            else
                chaine += "<li>" + utils.spanification(objet[i].reponse) + "</li>";
        }
        chaine += "</ol>";
        return chaine;
    },
    spanification: function (text) {
        var regexp = /\$\$([^$]*)\$\$/gi;
        if (regexp.test(text)) {
            text = text.replace(regexp, "<span class='math'>$1</span>");
        }
        return text;
    },
    //parse URL to get values: var i = getUrlVars()["i"];
    getUrlVars: function () {
        var vars = [], hash;
        var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
        for (var i = 0; i < hashes.length; i++) {
            hash = hashes[i].split('=');
            vars.push(hash[0]);
            vars[hash[0]] = hash[1];
        }
        return vars;
    },
    creerQuestions: function (option) {
        activite.nbq = $('#slidernbq').slider("value");
        $('#loader2').show();
        activite.enonce = Number($("input:radio[name='enonce']:checked").val());
        activite.tempo = $("#slidert").slider("value");
        if ($('input#pascache:checkbox').prop('checked'))
            activite.timeToShow = 0;
        else
            activite.timeToShow = $("#sliderc").slider("value");
        activite.autocorr = Number($("input:radio[name='autocorr']:checked").val());
        var taille = activite.tailleTexte;
        var compteur = 1;
        $('#questions').html('');
        utils.creerCanvas();
        var cpt = 0;
        if (activite.enonce == 1) { // enonce simple (tout le monde le même)
            for (i in activite.questions) {
                if (cpt >= activite.nbq)
                    break;
                cpt++;
                if (activite.questions[i].tex != undefined)
                    $("#questions").append("<div id='q" + compteur + "' class='invisible " + taille + " math'>" + activite.questions[i].tex + "</div>");
                else if (activite.questions[i].question != undefined)
                    $("#questions").append("<div id='q" + compteur + "' class='invisible'>" + utils.spanification(activite.questions[i].question) + "</div>");
                if (activite.questions[i].fonction !== undefined && activite.fonc == true) {
                    activite.questions[i].fonction(activite.questions[i].params, "canvas" + cpt);
                }
                compteur++;
            }
        }
        else { // enonce double (2 enonces différents en même temps
            // creation d'un tableau numeroté pour melanger ensuite
            var ttemp = [], ttemp2 = [], kk = 0, k, l, tmelange = [];
            for (k in activite.questions) {
                ttemp[kk] = activite.questions[k];
                kk++;
            }
            // melange
            for (v = 0; v < activite.nbq; v++) {
                tmelange[v] = v;
            }
            tmelange = this.melangeTable(tmelange);
            for (kk = 0; kk < activite.nbq; kk++) {
                activite.questionsMelangees[kk] = ttemp[tmelange[kk]];
            }
            for (l = 0; l < activite.nbq; l++) {
                //m = (l+2)%activite.nbq;
                if (ttemp[l].tex != undefined)
                    $("#questions").append("<div id='q" + compteur + "' class='invisible grand'><div class='enonce1 math'>" + ttemp[l].tex + "</div><div class='enonce2 math'>" + ttemp[tmelange[l]].tex + "</div></div>");
                else if (ttemp[l].question != undefined)
                    $("#questions").append("<div id='q" + compteur + "' class='invisible moyen'><div class='enonce1'>" + utils.spanification(ttemp[l].question) + "</div><div class='enonce2'>" + utils.spanification(ttemp[tmelange[l]].question) + "</div></div>");
                compteur++;
            }
        }
        this.creerCorrection(option);
    },
    creerCorrection: function (option) {
        if (!activite.fig && activite.tex && !activite.correctionMulticol || activite.enonce == 2) {
            if (activite.enonce == 1)
                $('#tabs-corr > div:first').html(this.objetToText(activite.questions));
            else {
                $('#tabs-corr > div:first').html("<div class='col50 reponse1'>" + this.objetToText(activite.questions) + "</div><div class='col50 reponse2'>" + this.objetToText(activite.questionsMelangees) + "</div><div class='clearfix'></div>");
            }
        } else {
            $('#tabs-corr > div:first').html('<div id="col1" class="correction"></div><div id="col2" class="correction"></div><div id="col3" class="correction"></div>');
            var compteur = 1;
            var col;
            var cpt = 0;
            for (i in activite.questions) {
                if (cpt >= activite.nbq)
                    break;
                cpt++;
                col = Math.ceil(compteur / 3);
                if (col == 4)
                    col = 3;
                if (activite.fonc || activite.fig) {
                    $('#tabs-corr > div #col' + col).append("<div><span class='gras'>" + compteur + ")</span> " + utils.spanification(activite.questions[i].reponse) + "<br /><canvas id='c" + compteur + "' class='fonc-correction'></canvas></div>");
                    activite.questions[i].fonction(activite.questions[i].params, 'c' + compteur);
                }
                else {
                    if (!activite.tex)
                        $('#tabs-corr > div #col' + col).append("<div><span class='gras'>" + compteur + ")</span> " + utils.spanification(activite.questions[i].reponse) + "</div></li>");
                    else
                        $('#tabs-corr > div #col' + col).append("<div><span class='gras'>" + compteur + ") <span class='math'>" + activite.questions[i].reponse + "</span></li>");
                }
                compteur++;
            }
            $('#tabs-corr > div').append('<div id="truc"></div>');
        }
        //copie dans l'historique
        utils.copieHistorique();
        maths.render();
        if (option === "exemple") { // on affiche de suite la correction
            utils.correction();
        } else { // on lance la question 1
            $('#loader2').hide();
            if (Number($("input:radio[name='decompter']:checked").val()) === 1) {
                utils.decompte(4);
            } else {
                utils.lancerQuestionnaire();
            }
        }
    },
    decompte: function (i) {
        if (i == 4)
            $('#decompte').show();
        i--;
        if (i > 0) {
            $("#decompte").css("fontSize", "3em");
            $("#decompte").html(i);
            $('#decompte').animate({fontSize: "30em"}, 1000, function () {
                utils.decompte(i);
            });
        } else {
            $('#decompte').hide();
            utils.lancerQuestionnaire();
        }
    },
    lancerQuestionnaire: function () {
        if ($("#affichage").hasClass("numeroImpair")) {
            $("#affichage").toggleClass("numeroImpair numeroPair");
            $("#numero").toggleClass("numeroImpair numeroPair");
        }
        activite.encours = 0;
        $('#affichage').show();
        $("#fond").show();
        $("#passage").show();
        intervalShow = 0;
        this.afficheQuestion();
        //intervalShow = setTimeout("utils.afficheQuestion();", activite.tempo*1000);
    },
    afficheQuestion: function () {
        if (activite.timeToShow == 0 && activite.encours > 0) {
            $('#q' + activite.encours).hide();
            $('#canvas' + activite.encours).hide();
        }
        if (intervalShow)
            clearInterval(intervalShow);
        activite.encours++;
        if (activite.encours > activite.nbq) {
            //$('#rep-graphique').hide();
            $("#numero").html("Fini");
            $("#passage").hide();
            if (activite.autocorr) {
                $('#messagefin').html("C'est terminé.<br />Préparez-vous à la correction.");

            } else {
                $('#messagefin').html("C'est terminé.<br />Posez vos stylos.");
            }
            $('#messagefin').show('slow');
            setTimeout("utils.correction()", 6000);
            return false;
        }
        $('#q' + activite.encours).show();
        if (activite.fig || activite.fonc)
            $('#canvas' + activite.encours).show();
        // gestion du chrono
        if (activite.timeToShow > 0)
            setTimeout("utils.cacherQuestion();", activite.timeToShow * 1000);
        activite.restant = activite.tempo;
        $("#chrono").html(activite.restant);
        $("#numero").html("Question n°" + activite.encours);
        $("#numero").toggleClass("numeroImpair numeroPair");
        $("#affichage").toggleClass("numeroImpair numeroPair");
        this.chrono(1);
        intervalShow = setTimeout("utils.afficheQuestion();", activite.tempo * 1000);
    },
    cacherQuestion: function () {
        if (activite.fig || activite.fonc) {
            $('#canvas' + activite.encours).hide();
        }
        /*if (activite.fonc || activite.fig) {
         $('#rep-graphique').hide();
         }*/
        $('#q' + activite.encours).hide();
    },
    creerCanvas: function () {
        var chaine = "";
        for (i = 1; i < 11; i++) {
            chaine += '<canvas id="canvas' + i + '" width="600" height="600" class="invisible"></canvas>';
        }
        $('#canvas').html(chaine);
    },
    correction: function () {
        $('#rep-graphique').hide();
        $('#messagefin').click();
        if (activite.autocorr)
            $('a[href="#tabs-corr"]').click();
        $("#fond").hide("slow");
        $("#passage").hide();
        $('#affichage').hide();
        $('#loader2').hide();
    },
    chrono: function (reset) {
        if (reset) {
            if (chronoTimer)
                clearInterval(chronoTimer);
            chronoTimer = setInterval("utils.chrono(0);", 1000);
        }
        $("#chrono").html(activite.restant--);
    },
    interrompre: function () {
        clearInterval(intervalShow);
        /*$('#rep-graphique').hide();*/
        $("#passage").hide();
        this.correction();
    },
    suivant: function () {
        utils.afficheQuestion();
    },
    clignottePause: function () {
        $("#pause").toggleClass("gris bleu");
    },
    pause: function () {
        if (intervalShow) {
            clearInterval(intervalShow);
            intervalShow = 0;
            if (chronoTimer)
                clearInterval(chronoTimer);// on coupe l'affichage du chrono.
            pauseClignotte = setInterval("utils.clignottePause()", 800);
        } else {
            intervalShow = setTimeout("utils.afficheQuestion();", activite.restant * 1000);
            clearInterval(pauseClignotte);
            $("#pause").removeClass().addClass("bleu");
            this.chrono(1);// on relance le chrono
        }
    },
    estEntier: function (value) {
        if ((parseFloat(value) === parseInt(value)) && !isNaN(value)) {
            return true;
        } else {
            return false;
        }
    },
    creerCanvaTracage: function (xinf, xsup, yinf, ysup, numero, axis) {
        // numero = id du canvas visé.
        if (axis === undefined)
            axis = false;
        var canvasRepresentation, board;
        canvasRepresentation = numero;
        board = new Graph({
            canvasId: canvasRepresentation,
            minX: xinf,
            minY: yinf,
            maxX: xsup,
            maxY: ysup,
            unitsPerTick: 1
        });
        return board;
    },
    copieHistorique: function ()
    {
        var enonce = "";
        enonce += "<ol>";
        var compteur = 0;
        for (i in activite.questions) {
            compteur++;
            if (activite.questions[i].tex != undefined)
                enonce += "<li class='math'>" + activite.questions[i].tex + "</li>";
            else
                enonce += "<li>" + utils.spanification(activite.questions[i].question) + "</li>";
            if (compteur >= activite.nbq)
                break;
        }
        enonce += "</ol>";
        if (activite.questionsMelangees.length > 0) {
            compteur = 0;
            enonce = "<table><tr><td class='reponse1'>" + enonce + "</td><td class='reponse2'><ol>";
            for (i in activite.questionsMelangees) {
                compteur++;
                if (activite.questionsMelangees[i].tex != undefined)
                    enonce += "<li class='math'>" + activite.questionsMelangees[i].tex + "</li>";
                else
                    enonce += "<li>" + utils.spanification(activite.questionsMelangees[i].question) + "</li>";
                if (compteur >= activite.nbq)
                    break;
            }
            enonce += "</ol></td></tr></table>";
        }
        // creation du lien avec les options de passage
        var d = $("input:radio[name='decompter']:checked").val();
        var c = 0
        if ($("input#pascache:checkbox").prop("checked")) c=1;
        var lien = "<a href='#"+activite.code+"?n="+activite.nbq+"&e="+activite.enonce+"&t="+activite.tempo+"&xc="+c+"&a="+activite.autocorr+"&tts="+activite.timeToShow+"&d="+d+"&o="+activite.option+"&cd="+activite.code+"' class='noprint'>LIEN de l'activité avec les mêmes paramètres.</a>";
        $("#historique").append(Date().toLocaleString() + "<div id='historique" + historique + "'><div class='tableau break'>Enoncé : " + activite.titre + " - "+lien+"<hr />" + enonce + "Correction<hr />" + $("#resultats").html() + "</div></div>");
        // Copie des canvas s'il y en a.
        //grab the context from your destination canvas
        if ($("#resultats" + " canvas").length !== 0) {
            for (i = 1; i <= activite.nbq; i++) {
                var destinationCanvas = $("#historique" + historique + " #c" + i).get(0);
                var destCtx = destinationCanvas.getContext('2d');
                var sourceCanvas = $("#resultats" + " #c" + i).get(0);
                //call its drawImage() function passing it the source canvas directly
                destCtx.drawImage(sourceCanvas, 0, 0);
            }
        }
        historique++;
    }
};
var maths = {
    premiers: [2, 3, 5, 7, 11, 13, 17, 19, 23, 29, 31, 37, 41, 43, 47, 53, 59, 61, 67, 71, 73, 79, 83, 89, 97, 101, 103, 107, 109, 113, 127, 131, 137, 139, 149, 151, 157, 163, 167, 173, 179, 181, 191, 193, 197, 199, 211, 223, 227, 229, 233, 239, 241, 251, 257, 263, 269, 271, 277, 281, 283, 293, 307, 311, 313, 317, 331, 337, 347, 349, 353, 359, 367, 373, 379, 383, 389, 397, 401, 409, 419, 421, 431, 433, 439, 443, 449, 457, 461, 463, 467, 479, 487, 491, 499, 503, 509, 521, 523, 541, 547, 557, 563, 569, 571, 577, 587, 593, 599, 601, 607, 613, 617, 619, 631, 641, 643, 647, 653, 659, 661, 673, 677, 683, 691, 701, 709, 719, 727, 733, 739, 743, 751, 757, 761, 769, 773, 787, 797, 809, 811, 821, 823, 827, 829, 839, 853, 857, 859, 863, 877, 881, 883, 887, 907, 911, 919, 929, 937, 941, 947, 953, 967, 971, 977, 983, 991, 997, 1009, 1013, 1019, 1021, 1031, 1033, 1039, 1049, 1051, 1061, 1063, 1069, 1087, 1091, 1093, 1097, 1103, 1109, 1117, 1123, 1129, 1151, 1153, 1163, 1171, 1181, 1187, 1193, 1201, 1213, 1217, 1223, 1229, 1231, 1237, 1249, 1259, 1277, 1279, 1283, 1289, 1291, 1297, 1301, 1303, 1307, 1319, 1321, 1327, 1361, 1367, 1373, 1381, 1399, 1409, 1423, 1427, 1429, 1433, 1439, 1447, 1451, 1453, 1459, 1471, 1481, 1483, 1487, 1489, 1493, 1499, 1511, 1523, 1531, 1543, 1549, 1553, 1559, 1567, 1571, 1579, 1583, 1597, 1601, 1607, 1609, 1613, 1619, 1621, 1627, 1637, 1657, 1663, 1667, 1669, 1693, 1697, 1699, 1709, 1721, 1723, 1733, 1741, 1747, 1753, 1759, 1777, 1783, 1787, 1789, 1801, 1811, 1823, 1831, 1847, 1861, 1867, 1871, 1873, 1877, 1879, 1889, 1901, 1907, 1913, 1931, 1933, 1949, 1951, 1973, 1979, 1987, 1993, 1997, 1999],
    pgcd: function (a, b) {
        return Algebrite.run('gcd('+a+','+b+')');
    },
    ppcm: function (a, b) {
       return Algebrite.run('lcm('+a+','+b+')');
    },
    simplifie: function (a, b, notex) {
        // retourne un tableau avec les nombres simplifiés et le pgcd
        // si notex est défini, renvoie un tableau, une fraction en latex sinon
        var pgcd = maths.pgcd(a, b);
        if (pgcd) {
            var signe = (a * b < 0) ? "-" : "";
            if (notex === undefined) {
                if (Math.abs(b) / pgcd == 1)
                    return signe + (Math.abs(a) / pgcd);
                else
                    return signe + "\\frac{" + (Math.abs(a) / pgcd) + "}{" + (Math.abs(b) / pgcd) + "}";
            } else
                return [signe + (Math.abs(a) / pgcd), Math.abs(b) / pgcd, pgcd];
        } else if (a == 0) {
            if (notex === undefined)
                return "0";
            else
                return [0, 1, 1];
        } else {
            alert('simplification impossible');
            return false;
        }
    },
    opererFractions: function (a, b, operation, notex) {
        // a et b array(numerateur, denominateur)
        // a[0] : numérateur a, a[1] : dénominateur a
        var ppcm = maths.ppcm(a[1], b[1]);
        if (operation == "+") {
            return maths.simplifie(a[0] * (ppcm / a[1]) + b[0] * (ppcm / b[1]), ppcm, notex);
        } else if (operation == "-") {
            return maths.simplifie(a[0] * (ppcm / a[1]) - b[0] * (ppcm / b[1]), ppcm, notex);
        } else if (operation == "*") {
            signe = (a[0] * b[0] * a[1] * b[1] < 0) ? -1 : 1;
            return maths.simplifie(signe * Math.abs(a[0] * b[0]), Math.abs(a[1] * b[1]), notex);
        } else if (operation == "/") {
            signe = (a[0] * b[0] * a[1] * b[1] < 0) ? -1 : 1;
            return maths.simplifie(signe * Math.abs(a[0] * b[1]), Math.abs(a[1] * b[0]), notex);
        } else
            return false;
    },
    ecritComplexe: function (abi) {
        // abi = [a, b, 'a+ib'], a et b entiers.
        // TODO : a et b fractions
        var ecriture = '';
        if (Array.isArray(abi[0])) {
            if (abi[0][0] !== 0) {
                ecriture += "\\frac{" + abi[0][0] + "}{" + abi[0][1] + "}";
            }
            if (abi[1][0] > 0) {
                ecriture += "+\\frac{" + abi[1][0] + "}{" + abi[1][1] + "}i";
            } else if (abi[1][0] < 0) {
                ecriture += "-\\frac{" + (-abi[1][0]) + "}{" + abi[1][1] + "}i";
            }
        } else {
            var deuxiemeTerme = maths.simplifieTerme(abi[1], "i");
            if (abi[0] === 0) {
                if (abi[1] !== 0) {
                    ecriture = deuxiemeTerme;
                } else
                    ecriture = '0';
            } else {
                ecriture = abi[0] + maths.simplifieTerme(abi[1], "i", true);
            }
        }
        return [abi[0], abi[1], ecriture];
    },
    decompose: function (a) {
        // a entier
        var i = 0, puissance = 0, top = Math.ceil(Math.sqrt(a)), nbaTemp = a, result = [];
        while (maths.premiers[i] <= top) {
            if (nbaTemp % maths.premiers[i] == 0) {
                nbaTemp = nbaTemp / maths.premiers[i];
                puissance++;
            } else {
                if (puissance > 0) {
                    result.push([maths.premiers[i], puissance]);
                    puissance = 0;
                }
                i++;
            }
        }
        if (nbaTemp == a)
            result.push([a, 1]);
        else if (nbaTemp > 1)
            result.push([nbaTemp, 1]);
        return result;
    },
    simplifieRacine: function (radicande) {
        // radicande entier
        // TODO : radicande fraction
        var reponsetemp = maths.decompose(radicande);
        var hr = 1;
        var ir = 1;
        var p, nb;
        for (k = 0; k < reponsetemp.length; k++) {
            nb = reponsetemp[k][0];
            p = reponsetemp[k][1];
            hr = hr * Math.pow(nb, Math.floor(p / 2));
            ir = ir * Math.pow(nb, p % 2);
        }
        if (hr === 1 && ir !== 1)
            hr = "";
        if (ir === 1)
            ir = "";
        else
            ir = "\\sqrt{" + ir + "}";
        return hr + ir;
    },
    calculeValeur: function (expression, variable, valeur) {
        var regexp = new RegExp(variable, "g");
        var value = eval(expression.replace(regexp, valeur));
        return value;
    },
    simplifieTerme: function (coefficient, variable, signer) {
        // coefficient : nombre décimal
        // variable : 'x', 't', ou ""
        // toujours renvoyer un signe - signer : true ou false
        coefficient = Number(coefficient);
        var sign = "";
        if (coefficient == 1 && variable != "") {
            if (signer)
                sign = "+";
            return sign + variable;
        } else if (coefficient == -1 && variable != "") {
            return "-" + variable
        } else if (coefficient == 0) {
            return "";
        } else {
            if (signer && coefficient > 0)
                sign = "+";
            return sign + coefficient + variable;
        }
    },
    arrondir: function (value, decimals) {
        return Number(Math.round(value + 'e' + decimals) + 'e-' + decimals);
    },
    valeurParDefaut: function (valeur, decimales) {
        return Number(Math.floor(valeur + 'e' + decimales)) + 'e-' + decimales;
    },
    valeurParExces: function (valeur, decimales) {
        return Number(Math.ceil(valeur + 'e' + decimales)) + 'e-' + decimales;
    },
    extraitProduits: function (listeNombres) {
        // fonction qui retourne tous les produits de 2 nombres obtenus par association des nombres d'une liste.
        var liste = [], i1, i2, i3, nb1, nb2;
        nb1 = listeNombres[0];
        nb2 = 1;
        for (i1 = 1; i1 < listeNombres.length; i1++) {
            nb2 = nb2 * listeNombres[i1];
        }
        if (nb1 < 11 && nb2 < 11)
            liste.push([nb1, nb2]);
        if (listeNombres.length > 2) {
            for (i1 = 1; i1 < listeNombres.length; i1++) {
                nb1 = listeNombres[0] * listeNombres[i1];
                nb2 = 1;
                for (i2 = 1; i2 < listeNombres.length; i2++) {
                    if (i2 !== i1)
                        nb2 = nb2 * listeNombres[i2];
                }
                if (nb1 < 11 && nb2 < 11 && liste.indexOfForArrays([nb1, nb2]) === -1 && liste.indexOfForArrays([nb2, nb1]) === -1)
                    liste.push([nb1, nb2]);
            }
        }
        if (listeNombres.length > 3) {
            for (i1 = 1; i1 < listeNombres.length; i1++) {
                for (i2 = i1 + 1; i2 < listeNombres.length; i2++) {
                    nb1 = listeNombres[0] * listeNombres[i1] * listeNombres[i2];
                    nb2 = 1;
                    for (i3 = 1; i3 < listeNombres.length; i3++) {
                        if (i3 !== i1 && i3 !== i2)
                            nb2 = nb2 * listeNombres[i3];
                    }
                    if (nb1 < 11 && nb2 < 11 && liste.indexOfForArrays([nb1, nb2]) === -1 && liste.indexOfForArrays([nb2, nb1]) === -1)
                        liste.push([nb1, nb2]);
                }
            }
        }
        return liste;
    },
    render: function () {
        $(".math").each(function () {
            var texTxt = $(this).text();
            el = $(this).get(0);
            if (el.tagName == "DIV" || el.tagNAME == "SPAN") {
                addDisp = "\\displaystyle";
            } else {
                addDisp = "";// ajout seb pour affichage correct des fractions dans les phrases.
            }
            try {
                katex.render(addDisp + texTxt, el, {throwOnError: false, errorColor: "#FFF"});
                $(this).removeClass("math");
            }
            catch (err) {
                $(this).html("<span class='err'>" + err + '</span>');
            }
            ;
        });
    }
}
geometrie = {
    marqueAngleDroit: function (figure, points, taille) {
        if (taille == undefined)
            taille = 30;
        var cu = points[1] + points[2] + points[3];
        figure.construct("s1" + cu + "=[" + points[1] + " " + points[0] + "] invisible;s2" + cu + "=[" + points[1] + " " + points[2] + "] invisible;cc" + cu + "=k(" + points[1] + "," + taille + ") invisible;PR" + cu + "=cc" + cu + "&s1" + cu + " invisible;PQ" + cu + "=cc" + cu + "&s2" + cu + " invisible;dr" + cu + "=|_(PR" + cu + "_1,s1" + cu + ") invisible;dq" + cu + "=|_(PQ" + cu + "_1,s2" + cu + ") invisible;PP" + cu + "=dr" + cu + "&dq" + cu + " invisible;[PR" + cu + "_1 PP" + cu + "];[PP" + cu + " PQ" + cu + "_1];");
    },
    traceAngle: function (params, numero) {
        var xinf = -4.5;
        var xsup = 4.5;
        var yinf = -3;
        var ysup = 3;
        var board = utils.creerCanvaTracage(xinf, xsup, yinf, ysup, numero);
        var xb, yb;
        if (params.angle == 90) {
            xb = 0;
            yb = 1;
        } else {
            var angle = params.angle / 180 * Math.PI;
            xb = Math.cos(angle);
            yb = Math.sin(angle);
        }
        var construction = board.construct("O(0,0);A(1,0);B(" + xb + "," + yb + ");[OA[;[OB[");
        board.create('angle', [construction.A, construction.O, construction.B], {name: ""});
        construction.A.visible(false);
        construction.B.visible(false);
        construction.O.visible(false);
        t = board.create('transform', [params.rotation], {type: 'rotate'});
        t.applyOnce([construction.A, construction.B]);
        board.update();
    },
    traceTriangle: function (params, numero) {
        // params :
        //{longueurs:{a,b,c},points:{a:"A",b:"B",c:"C"},rotation:(en radians),numero:id du canevas}
        var xinf = -50;
        var xsup = 550;
        var yinf = -25;
        var ysup = 375;
        var board = utils.creerCanvaTracage(xinf, xsup, yinf, ysup, numero);
        var a = params.longueurs.a;
        var pta = params.points.a;
        var b = params.longueurs.b;
        var ptb = params.points.b;
        var c = params.longueurs.c;
        var ptc = params.points.c;
        var rect = false;
        var iso = false;
        var equi = false;
        var angledroit = [];

        // coordonnées du point A
        xa = (a * a + c * c - b * b) / (2 * a);
        ya = c * Math.sqrt(1 - (b * b - a * a - c * c) * (b * b - a * a - c * c) / (4 * a * a * c * c));
        // mise à l'échelle
        echelle = Math.min((ysup - 15) / a, (ysup - 15) / c, (ysup - 15) / b);
        lb = echelle * b;
        lc = echelle * c;
        la = echelle * a;
        xa = echelle * xa;
        ya = echelle * ya;
        // construction du triangle
        var bc = board.construct(ptb + "(0,0);" + ptc + "(" + la + ",0);" + pta + "(" + xa + "," + ya + ");");
        board.create('polygon', [bc[pta], bc[ptb], bc[ptc]], {fillColor: "#CCCCCC"});
        // codage angle droit si demandé de coder
        // le triangle est-il rectangle ?
        if (a * a == b * b + c * c) {
            rect = true;
            angledroit = [ptb, pta, ptc];
        } else if (a * a + b * b == c * c) {
            rect = true;
            angledroit = [pta, ptc, ptb];
        } else if (a * a + c * c == b * b) {
            rect = true;
            angledroit = [pta, ptb, ptc];
        }
        if (rect && params.coder) {
            geometrie.marqueAngleDroit(board, angledroit);
        }
        // cercle circonscrit
        if (params.circ) {
            board.create('circle', [bc[pta], bc[ptb], bc[ptc]]);
        }

        // codage des longueurs
        if (params.mesures) {
            var taille = 12
            if (numero > 0)
                taille = 8;
            var marque = ">";
            var color = "green";
            var paramsCommuns = {name: "", face: marque, size: taille, color: "transparent", strokeColor: color};
            if (a == b && b == c) {
                equi = true;
                board.create('midpoint', [bc[ptc], bc[ptb]], paramsCommuns);
                board.create('midpoint', [bc[pta], bc[ptb]], paramsCommuns);
                board.create('midpoint', [bc[pta], bc[ptc]], paramsCommuns);
            } else if (a == b) {
                iso = true;
                board.create('midpoint', [bc[ptc], bc[ptb]], paramsCommuns);
                board.create('midpoint', [bc[pta], bc[ptc]], paramsCommuns);
            } else if (b == c) {
                iso = true;
                board.create('midpoint', [bc[pta], bc[ptb]], paramsCommuns);
                board.create('midpoint', [bc[pta], bc[ptc]], paramsCommuns);
            } else if (c == a) {
                iso = true;
                board.create('midpoint', [bc[ptc], bc[ptb]], paramsCommuns);
                board.create('midpoint', [bc[pta], bc[ptb]], paramsCommuns);
            }
            /*board.create('text',[la/2,30,a]);
             board.create('text',[(la+xa)/2+15,ya/2,b]);
             board.create('text',[xa/2-35,ya/2-10,c]);*/
        }
        return "construit";
    },
    traceFonction: function (params, numero) {
        if (params.xinf === undefined)
            params.xinf = -5;
        if (params.xsup === undefined)
            params.xsup = 5;
        if (params.yinf === undefined)
            params.yinf = -3;
        if (params.ysup === undefined)
            params.ysup = 3;
        var board = utils.creerCanvaTracage(params.xinf, params.xsup, params.yinf, params.ysup, numero, true);
        board.drawEquation(function (x) {
            return eval(params.expression);
        }, 'green', 3);
        // placement des poins sur la représentation
        if (params.valeurs !== undefined) {
            board.drawPoint(params.valeurs[0], params.valeurs[1]);
            board.drawSegment(params.valeurs[0], 0, params.valeurs[0], params.valeurs[1], 2);
            board.drawSegment(params.valeurs[0], params.valeurs[1], 0, params.valeurs[1], 2);
        }
    },
    carre: function (params, numero) {
        var xinf = -3;
        var xsup = 3;
        var yinf = -2;
        var ysup = 2;
        var points = ["A", "B", "C", "D"];
        var board = utils.creerCanvaTracage(xinf, xsup, yinf, ysup, numero);
        if (params.points != undefined)
            points = params.points;
        var pA = board.create('point', [1, -1], {name: points[0]});
        var pB = board.create('point', [1, 1], {name: points[1]});
        var pC = board.create('point', [-1, 1], {name: points[2]});
        var pD = board.create('point', [-1, -1], {name: points[3]});
        var pol1 = board.create('polygon', [points[0], points[1], points[2], points[3]]);
        if (params.diagonales) {
            var diags = board.construct("d1=[" + points[0] + " " + points[2] + "] nolabel;d2=[" + points[1] + " " + points[3] + "] nolabel;I=d1&d2 invisible;")
            var diag1 = board.create('line', [pA, pC], {straightFirst: false, straightLast: false, strokeWidth: 2, dash: 2});
            var diag2 = board.create('line', [pB, pD], {straightFirst: false, straightLast: false, strokeWidth: 2, dash: 2});
            var pI = board.create('intersection', [diag1, diag2, 0], {name: "I"});
// codages des diagonales
            board.create('text', [(pA.X() + pI.X()) / 2, (pA.Y() + pI.Y()) / 2, '∆']);
            board.create('text', [(pB.X() + pI.X()) / 2, (pB.Y() + pI.Y()) / 2, '∆']);
            board.create('text', [(pC.X() + pI.X()) / 2, (pC.Y() + pI.Y()) / 2, '∆']);
            board.create('text', [(pD.X() + pI.X()) / 2, (pD.Y() + pI.Y()) / 2, '∆']);
        }
        if (params.cotes) {
            board.create('text', [(pA.X() + pB.X()) / 2, (pA.Y() + pB.Y()) / 2, '=']);
            board.create('text', [(pB.X() + pC.X()) / 2, (pB.Y() + pC.Y()) / 2, '//']);
            board.create('text', [(pC.X() + pD.X()) / 2, (pC.Y() + pD.Y()) / 2, '=']);
            board.create('text', [(pD.X() + pA.X()) / 2, (pD.Y() + pA.Y()) / 2, '//']);
        }
        if (params.lcote) {
            board.create('text', [pA.X(), pA.Y(), params.lcote]);
        }
        if (params.angles) {
            geometrie.marqueAngleDroit(board, [points[0], points[1], points[2]]);
            geometrie.marqueAngleDroit(board, [points[1], points[2], points[3]]);
            geometrie.marqueAngleDroit(board, [points[2], points[3], points[0]]);
            geometrie.marqueAngleDroit(board, [points[3], points[0], points[1]]);
        }
        if (params.anglediags) {
            geometrie.marqueAngleDroit(board, [points[0], "I", points[1]]);
        }
    },
    losange: function (params, numero) {
        var xinf = -3;
        var xsup = 3;
        var yinf = -2;
        var ysup = 2;
        var points = ["A", "B", "C", "D"];
        if (params.points != undefined)
            points = params.points;
        var board = utils.creerCanvaTracage(xinf, xsup, yinf, ysup, numero);
        var losange = board.construct(points[0] + "(2,0);" + points[1] + "(0,1);" + points[2] + "(-2,0);" + points[3] + "(0,-1);P[" + points[0] + "," + points[1] + "," + points[2] + "," + points[3] + "] nolabel;");
        if (params.diagonales) {
            var diags = board.construct("d1=[" + points[0] + " " + points[2] + "] nolabel;d2=[" + points[1] + " " + points[3] + "] nolabel;I=d1&d2 invisible;")
            var marque = "o";
            var marque2 = "<>";
            var taille = 11;
            var color = "green";
            var color2 = "grey";
            if (numero > 0)
                taille = 6;
            var paramsld1 = {name: "", face: marque, size: taille, color: "transparent", strokeColor: color};
            var paramsld2 = {name: "", face: marque2, size: taille, color: "transparent", strokeColor: color2};
            board.create('midpoint', [diags.I, losange[points[0]]], paramsld1);
            board.create('midpoint', [diags.I, losange[points[1]]], paramsld2);
            board.create('midpoint', [diags.I, losange[points[2]]], paramsld1);
            board.create('midpoint', [diags.I, losange[points[3]]], paramsld2);
        }
        if (params.cotes) {
            var marquec = "[]";
            var taillec = 11;
            var colorc = "blue";
            if (numero > 0)
                taillec = 6;
            var paramscot = {name: "", face: marquec, size: taillec, color: "transparent", strokeColor: colorc};
            board.create('midpoint', [losange[points[0]], losange[points[1]]], paramscot);
            board.create('midpoint', [losange[points[1]], losange[points[2]]], paramscot);
            board.create('midpoint', [losange[points[2]], losange[points[3]]], paramscot);
            board.create('midpoint', [losange[points[3]], losange[points[0]]], paramscot);
        }
        if (params.anglediags) {
            geometrie.marqueAngleDroit(board, [points[0], "I", points[1]]);
        }
    },
    rectangle: function (params, numero) {
        var xinf = -3;
        var xsup = 3;
        var yinf = -2;
        var ysup = 2;
        var board = utils.creerCanvaTracage(xinf, xsup, yinf, ysup, numero);
        var rectangle = board.construct("A(2,-1);B(2,1);C(-2,1);D(-2,-1);P[A,B,C,D] nolabel;");
        if (params.diagonales) {
            var diags = board.construct("d1=[AC] nolabel;d2=[BD] nolabel;I=d1&d2 invisible;")
            var marque = "o";
            var marque2 = "<>";
            var taille = 11;
            var color = "green";
            var color2 = "grey";
            if (numero > 0)
                taille = 6;
            board.create('midpoint', [diags.I, rectangle.A], {name: "", face: marque, size: taille, color: "transparent", strokeColor: color});
            board.create('midpoint', [diags.I, rectangle.B], {name: "", face: marque, size: taille, color: "transparent", strokeColor: color});
            board.create('midpoint', [diags.I, rectangle.C], {name: "", face: marque, size: taille, color: "transparent", strokeColor: color});
            board.create('midpoint', [diags.I, rectangle.D], {name: "", face: marque, size: taille, color: "transparent", strokeColor: color});
        }
    },
    parallelogramme: function (params, numero) {
        var xinf = -3;
        var xsup = 3;
        var yinf = -2;
        var ysup = 2;
        var decal = 0.5;
        decal = decal * (utils.entier(-2, 2));
        var board = utils.creerCanvaTracage(xinf, xsup, yinf, ysup, numero);
        var parallelogramme = board.construct("A(" + (1 + decal) + ",-1);B(1,1);C(-1,1);D(" + (-1 + decal) + ",-1);P[A,B,C,D] nolabel;");
        if (params.diagonales) {
            var diags = board.construct("d1=[AC] nolabel;d2=[BD] nolabel;I=d1&d2 invisible;")
            var marque = "o";
            var marque2 = "<>";
            var taille = 11;
            var color = "green";
            var color2 = "grey";
            if (numero > 0)
                taille = 6;
            board.create('midpoint', [diags.I, parallelogramme.A], {name: "", face: marque, size: taille, color: "transparent", strokeColor: color});
            board.create('midpoint', [diags.I, parallelogramme.B], {name: "", face: marque2, size: taille, color: "transparent", strokeColor: color2});
            board.create('midpoint', [diags.I, parallelogramme.C], {name: "", face: marque, size: taille, color: "transparent", strokeColor: color});
            board.create('midpoint', [diags.I, parallelogramme.D], {name: "", face: marque2, size: taille, color: "transparent", strokeColor: color2});
        }
    }
}
Graph = function (config) {
    // user defined properties
    this.canvas = document.getElementById(config.canvasId);
    this.minX = config.minX;
    this.minY = config.minY;
    this.maxX = config.maxX;
    this.maxY = config.maxY;
    this.unitsPerTick = config.unitsPerTick;

    // constants
    this.axisColor = '#aaa';
    this.font = '8pt Arial';
    this.tickSize = 10;

    // relationships
    this.context = this.canvas.getContext('2d');
    this.rangeX = this.maxX - this.minX;
    this.rangeY = this.maxY - this.minY;
    this.unitX = this.canvas.width / this.rangeX;
    this.unitY = this.canvas.height / this.rangeY;
    this.centerY = Math.round(Math.abs(this.minY / this.rangeY) * this.canvas.height);
    this.centerX = Math.round(Math.abs(this.minX / this.rangeX) * this.canvas.width);
    this.iteration = (this.maxX - this.minX) / 1000;
    this.scaleX = this.canvas.width / this.rangeX;
    this.scaleY = this.canvas.height / this.rangeY;

    // draw x and y axis
    this.drawXAxis();
    this.drawYAxis();
}

Graph.prototype.drawXAxis = function () {
    var context = this.context;
    context.save();
    context.beginPath();
    context.moveTo(0, this.centerY);
    context.lineTo(this.canvas.width, this.centerY);
    context.strokeStyle = this.axisColor;
    context.lineWidth = 2;
    context.stroke();

    // draw tick marks
    var xPosIncrement = this.unitsPerTick * this.unitX;
    var xPos, unit;
    context.font = this.font;
    context.textAlign = 'center';
    context.textBaseline = 'top';

    // draw left tick marks
    xPos = this.centerX - xPosIncrement;
    unit = -1 * this.unitsPerTick;
    while (xPos > 0) {
        context.moveTo(xPos, this.centerY - this.tickSize / 2);
        context.lineTo(xPos, this.centerY + this.tickSize / 2);
        context.stroke();
        context.fillText(unit, xPos, this.centerY + this.tickSize / 2 + 3);
        unit -= this.unitsPerTick;
        xPos = Math.round(xPos - xPosIncrement);
    }

    // draw right tick marks
    xPos = this.centerX + xPosIncrement;
    unit = this.unitsPerTick;
    while (xPos < this.canvas.width) {
        context.moveTo(xPos, this.centerY - this.tickSize / 2);
        context.lineTo(xPos, this.centerY + this.tickSize / 2);
        context.stroke();
        context.fillText(unit, xPos, this.centerY + this.tickSize / 2 + 3);
        unit += this.unitsPerTick;
        xPos = Math.round(xPos + xPosIncrement);
    }
    context.restore();
};

Graph.prototype.drawYAxis = function () {
    var context = this.context;
    context.save();
    context.beginPath();
    context.moveTo(this.centerX, 0);
    context.lineTo(this.centerX, this.canvas.height);
    context.strokeStyle = this.axisColor;
    context.lineWidth = 2;
    context.stroke();

    // draw tick marks
    var yPosIncrement = this.unitsPerTick * this.unitY;
    var yPos, unit;
    context.font = this.font;
    context.textAlign = 'right';
    context.textBaseline = 'middle';

    // draw top tick marks
    yPos = this.centerY - yPosIncrement;
    unit = this.unitsPerTick;
    while (yPos > 0) {
        context.moveTo(this.centerX - this.tickSize / 2, yPos);
        context.lineTo(this.centerX + this.tickSize / 2, yPos);
        context.stroke();
        context.fillText(unit, this.centerX - this.tickSize / 2 - 3, yPos);
        unit += this.unitsPerTick;
        yPos = Math.round(yPos - yPosIncrement);
    }

    // draw bottom tick marks
    yPos = this.centerY + yPosIncrement;
    unit = -1 * this.unitsPerTick;
    while (yPos < this.canvas.height) {
        context.moveTo(this.centerX - this.tickSize / 2, yPos);
        context.lineTo(this.centerX + this.tickSize / 2, yPos);
        context.stroke();
        context.fillText(unit, this.centerX - this.tickSize / 2 - 3, yPos);
        unit -= this.unitsPerTick;
        yPos = Math.round(yPos + yPosIncrement);
    }
    context.restore();
};

Graph.prototype.drawEquation = function (equation, color, thickness) {
    var context = this.context;
    context.save();
    context.save();
    this.transformContext();

    context.beginPath();
    context.moveTo(this.minX, equation(this.minX));

    for (var x = this.minX + this.iteration; x <= this.maxX; x += this.iteration) {
        context.lineTo(x, equation(x));
    }

    context.restore();
    context.lineJoin = 'round';
    context.lineWidth = thickness;
    context.strokeStyle = color;
    context.stroke();
    context.restore();
};

Graph.prototype.drawSegment = function (x1, y1, x2, y2, thickness, dash, color) {
    var context = this.context;
    if (dash === undefined)
        dash = 10;
    if (color === undefined)
        color = 'blue';
    context.save();
    context.save();
    this.transformContext();

    context.beginPath();
    context.moveTo(x1, y1);
    context.lineTo(x2, y2);
    context.restore();
    context.lineJoin = 'round';
    context.lineWidth = thickness;
    context.strokeStyle = color;
    context.setLineDash([dash]);
    context.stroke();
    context.restore();
};

Graph.prototype.drawPoint = function (x, y) {
    var context = this.context;
    context.save();
    context.save();
    this.transformContext();
    context.beginPath();
    context.moveTo(x - 0.1, y - 0.1);
    context.lineTo(x + 0.1, y + 0.1);
    context.moveTo(x - 0.1, y + 0.1);
    context.lineTo(x + 0.1, y - 0.1);
    context.restore();
    context.lineWidth = 2;
    context.stroke();
    context.restore();
};

Graph.prototype.drawCircle = function (x, y, r) {
    var context = this.context;
    context.save();
    context.save();
    this.transformContext();
    context.beginPath();
    context.arc(x, y, r, 0, 2 * Math.PI);
    context.restore();
    context.stroke();
    context.restore();
    this.drawPoint(x, y);
};

Graph.prototype.transformContext = function () {
    var context = this.context;
    // move context to center of canvas
    this.context.translate(this.centerX, this.centerY);
    /*
     * stretch grid to fit the canvas window, and
     * invert the y scale so that that increments
     * as you move upwards
     */
    context.scale(this.scaleX, -this.scaleY);
};
/* Exemple
 var myGraph = new Graph({
 canvasId: 'myCanvas',
 minX: -10,
 minY: -10,
 maxX: 10,
 maxY: 10,
 unitsPerTick: 1
 });
 
 myGraph.drawEquation(function (x) {
 return 5 * Math.sin(x);
 }, 'green', 3);
 */